% A generic procedure to invoke ZOM functions and return codes to the ODBC Driver.
% Bressan - 13/08/15 - Disable dependencies and format the error code.
% Bressan - 13/04/16 - Interaction between ZOM and IDE.
procedure pZOMCall(in Action, out ErrCode, out ErrMsg) local(lObjKey)
   if $position($DirPath(), ";$ZOM(") > 0
      let vZOMDepTrace = $False
      let vZOMError = $null
      let vZOMErrorMsg = ""
   endif
   let <TheAction> = Action
   let $LastErrCode = 0
   let $LastErrMessage = ""

   let lObjKey = $null
   #<TheAction>

   if $position($DirPath(), ";$ZOM(") > 0
      if vZOMError is not $null
         let ErrCode = vZOMError
         let ErrMsg = vZOMErrorMsg
      elseif $LastErrCode > 0
         let ErrCode = $mask({$LastErrCode, 0},"9999")
         let ErrMsg = $LastErrMessage
      else
         let ErrCode = "0000"
         let ErrMsg = $LastErrMessage
      endif
   else
      let ErrCode = $mask({$LastErrCode, 0},"9999")
      let ErrMsg = $LastErrMessage
   endif
   if lObjKey is not $null and ErrCode = "0000"
      let ErrMsg = lObjKey
   endif
endprocedure
