procedure UpdateDC(out vlStatus) local (vlResponse)    
   set database access exclusive
   
   % Just in case more than one user got into here.
   if $DCRevision = $CurrentDCRevision
      set database access shared
      return
   endif

   % Database not initialized yet.
   if $DCRevision = 0.0
      if $zimos = 11 %% windows
         system '!mkdir dcrt' invisible remote
         system '!mkdir dpsrt' invisible remote
         system $concat("!copy ", '"',$ZIMPath, "\\init\\dpsrt\\*.*",'"', " dpsrt") invisible remote
         system $concat("!copy ", '"',$ZIMPath, "\\init\\dcrt\\*.*",'"', " dcrt") invisible remote
      else %% unix
         system 'mkdir -p dcrt' remote
         system 'mkdir -p dpsrt' remote
         system $concat("cp -R ", $ZIMPath, "/init/dpsrt ", $DBPath) remote
         system $concat("cp -R ", $ZIMPath, "/init/dcrt ", $DBPath) remote
      endif   
   endif

   % These two guys need to exist all the time.
   if $zimos = 11 %% windows
      system '!mkdir port' invisible remote
      system '!mkdir zomsaving' invisible remote
   else %% unix
      system 'mkdir -p port' invisible remote
      system 'mkdir -p zomsaving' invisible remote
   endif   
   
   % DC already ran it.
   if vZomOperationMode is $null or vZomOperationMode <> "DC"
      output "Updating the Object Dictionary ..."
      $utils.pZIMBoot2(vlStatus)
      output "Update completed."
      if vlStatus <> "OK"
         RETURN
      endif
   endif

   SET SAVE
   output "Updating Services..."
   $DevCen.pZIMBoot3(vlStatus)
   output "Update completed."
   SET RESTORE

   set database access shared
endprocedure
